import Foundation

class MenuContentCreater {
    
    private init(){}
    
    static let shared = MenuContentCreater()
    
    let emojiSet: [String:[String]] = [
        "faces" : ["😀","😁","😍","😂","😊","🙃","😙","😜","🤑","😎","😏","😔","🙁","😖","😤","😶","😃","😆","🤣","😇","😉","😘","😚","😝","🤗","😒","😟","☹️","😫","😠","😐","😄","😅","☺️","🙂","😌","😗","😋","😛","🤓","🤠","😞","😕","😣","😩","😑","😯","😮","😳","😰","🤤","😪","🤔","🤐","😷","😦","😲","😱","😢","😭","😴","🤥","🤒","😧","😵","😨","😥","😓","🙄","😬","🤧","🤕"],
        "people": ["👮","💂‍♀️","🕵️","👩‍🌾","👨‍🍳","👩‍🎤","👨‍🏫","👩‍💻","👩‍🔬","👨‍🎨","👩‍✈️","👨‍🚀","👷‍♀️","💂","👩‍⚕️","👨‍🌾","👩‍🎓","👨‍🎤","👩‍🏭","👨‍💻","👩‍🔧","👨‍🔬","👩‍🚒","👨‍✈️","👲","👮‍♀️","👷","🕵️‍♀️","👨‍⚕️","👩‍🍳","👨‍🎓","👩‍🏫","👨‍🏭","👩‍💼","👨‍🔧","👩‍🎨","👨‍🚒","👩‍🚀","👨‍⚖️","🙇","🙅","🙆‍♂️","🤦‍♀️","🤷‍♂️","🙍","💇‍♂️","🕴","👯","🚶","👫","💑","💏","👰","🤰","💁","🙅‍♂️","🙋","🤦‍♂️","🙎","🙍‍♂️","💆","💃","👯‍♂️","🏃‍♀️","👭","👩‍❤️‍👩","👩‍❤️‍💋‍👩"],
        "animals" : ["🦅","🐺","🦄","🦋","🐞","🦎","🐒","🦉","🐗","🐝","🐌","🐜","🐢","🦂","🐔","🦆","🦇","🐴","🐛","🐚","🕷","🐍","🦀","🦑","🐠","🐬","🐋","🐅","🐄","🐫","🦍","🐐","🐕","🐓","🐇","🐿","🐙","🐟","🦈","🐊","🐃","🦌","🐘","🐎","🐏","🐩","🦃","🐁","🦐","🐆","🐂","🐪","🦏","🐖","🐑","🐈","🕊","🐀","🐉"],
        "objects" : ["⌚️","💻","🖨","🕹","💾","📼","📹","🎞","📟","📻","🎛","⏰","⏳","🔌","🎥","📞","💡","🗑","💵","📸","📽","☎️","📺","🎚","⏲","⌛️","🔋","🔦","🛢","🛎","🔨","🚽","🛁","🔑","🔬","🗝","🛍","🛒","🎉","🎁","🎀","📫","🔎","🔒"],
        "food" : ["🍏","🍊","🍉","🍍","🍅","🥕","🥔","🥜","🍞","🍖","🍔","🌮","🥘","🍎","🍇","🍒","🥝","🍆","🌽","🍠","🥖","🍳","🍤","🍕","🍟","🌯","🍝","🍐","🍌","🍓","🍑","🥑","🥒","🌶","🥐","🥓","🍗","🌭","🥙","🍜","🍡","🍦","🍫","🍪","☕️","🍺","🍷","🍹","🍥","🍛","🍘","🍧","🍰","🍭","🍿","🍻","🍣","🍙","🍢","🍨","🎂","🍬","🍩","🥂","🍸"],
        "activity" : ["🏸","🏑","🏹","🥋","🥅","🏏","🎣","⛸","🚣","🏓","🏒","⛳️","🥊","🎿","🎖","🥉","🎗","🎭","🎤","🎹","🎺","🎮","🎽","🥇","🏆","🎨","🎧","🥁","🎸","🎯","🎰","🏅","🥈","🎟","🎬","🎼","🎷","🎻","🎳"],
        "travel" : ["🚌","🚓","🚐","🚜","🛵","🚔","🚖","🚟","🚞","🚅","🚆","🚉","✈️","🚀","🛶","🚕","🚎","🚑","🚚","🛴","🏍","🚍","🚡","🚃","🚝","🚈","🚇","🚁","🛫","🛰","⛵️","🚙","🏎","🚒","🚛","🚲","🚘","🚠","🚋","🚄","🚂","🚊","🛩","🛥","🚤","🚢","🛳"],
        "symbols" : ["❤️","💙","💔","💞","💖","💟","💜","❣️","💓","💘","☮️","💚","🖤","💕","💗","💝","✝️","🈶","🈚️","🈷","💮","㊗️","🅱️","🅾️","⭕️","📛","💢","🚯","🔞","❗️","❔","🔅","⚠️","🈸","✴️","🆎","🆘","🛑","🚫","♨️","🚳","❕","‼️","🔆","🚸","🈺","🅰️","❌","⛔️","💯","🚷","🚱","🚭","❓","⁉️","〽️","🔱","⚜️","✅","❇️","🌐","🌀","🚾","🈳","🛃","🚹","🚻","📶","ℹ️","🔠","🆙","🆓","2️⃣","🔰","🈯️","✳️","💠","💤","♿️","🈂","🛄","🚺","🚮","🈁","🔤","🆖","🆒","0️⃣","3️⃣","♻️","💹","❎","Ⓜ️","🏧","🅿️","🛂","🛅","🚼","🎦","🔡","🆗","🆕","1️⃣","4️⃣","5️⃣","8️⃣","🔢","▶️","⏹","⏮","⏫","🔼","⬅️","↗️","↖️","↪️","⤵️","🔂","🎵","➖","6️⃣","9️⃣","#️⃣","⏸","⏺","⏩","⏬","🔽","⬆️","↘️","↕️","↩️","🔀","🔄","🎶","➗","7️⃣","🔟","*️⃣","⏯","⏭","⏪","◀️","➡️","⬇️","↙️","↔️","⤴️","🔁","🔃","©","➰","🔴","🔻","🔶","🔈","📣","💬","⚪️","🔵","🔸","🔷","🔇","🔔","📢","💭","🔝","☑️","⚫️","🔺","🔹","🔉","🔕","👁‍🗨","🗯","♠️","♦️","🀄️"],
        "flags" : ["🏳","🚩","🇦🇽","🇦🇸","🇦🇮","🇦🇷","🇦🇺","🇧🇸","🇧🇧","🇧🇿","🇧🇹","🇧🇼","🇻🇬","🇧🇫","🇨🇲","🇨🇻","🏴","🏳️‍🌈","🇦🇱","🇦🇩","🇦🇶","🇦🇲","🇦🇹","🇧🇭","🇧🇾","🇧🇯","🇧🇴","🇧🇷","🇧🇳","🇧🇮","🇨🇦","🇧🇶","🏁","🇦🇫","🇩🇿","🇦🇴","🇦🇬","🇦🇼","🇦🇿","🇧🇩","🇧🇪","🇧🇲","🇧🇦","🇮🇴","🇧🇬","🇰🇭","🇮🇨","🇰🇾","🇨🇫","🇨🇳","🇨🇴","🇨🇩","🇨🇮","🇨🇼","🇩🇰","🇩🇴","🇸🇻","🇪🇪","🇫🇰","🇫🇮","🇵🇫","🇬🇲","🇬🇭","🇬🇱","🇹🇩","🇨🇽","🇰🇲","🇨🇰","🇭🇷","🇨🇾","🇩🇯","🇪🇨","🇬🇶","🇪🇹","🇫🇴","🇫🇷","🇹🇫","🇬🇪","🇬🇮","🇬🇩","🇨🇱","🇨🇨","🇨🇬","🇨🇷","🇨🇺","🇨🇿","🇩🇲","🇪🇬","🇪🇷","🇪🇺","🇫🇯","🇬🇫","🇬🇦","🇩🇪","🇬🇷","🇬🇵","🇬🇺","🇬🇳","🇭🇹","🇭🇺","🇮🇩","🇮🇪","🇮🇹","🎌","🇰🇿","🇽🇰","🇱🇦","🇱🇸","🇱🇮","🇲🇴","🇲🇼","🇲🇱","🇬🇹","🇬🇼","🇭🇳","🇮🇸","🇮🇷","🇮🇲","🇯🇲","🇯🇪","🇰🇪","🇰🇼","🇱🇻","🇱🇷","🇱🇹","🇲🇰","🇲🇾","🇲🇹","🇬🇬","🇬🇾","🇭🇰","🇮🇳","🇮🇶","🇮🇱","🇯🇵","🇯🇴","🇰🇮","🇰🇬","🇱🇧","🇱🇾","🇱🇺","🇲🇬","🇲🇻","🇲🇭","🇲🇶","🇾🇹","🇲🇩","🇲🇪","🇲🇿","🇳🇷","🇳🇨","🇳🇪","🇳🇫","🇳🇴","🇵🇼","🇵🇬","🇵🇭","🇵🇹","🇷🇪","🇷🇼","🇲🇷","🇲🇽","🇲🇨","🇲🇸","🇲🇲","🇳🇵","🇳🇿","🇳🇬","🇰🇵","🇴🇲","🇵🇸","🇵🇾","🇵🇳","🇵🇷","🇷🇴","🇼🇸","🇲🇺","🇫🇲","🇲🇳","🇲🇦","🇳🇦","🇳🇱","🇳🇮","🇳🇺","🇲🇵","🇵🇰","🇵🇦","🇵🇪","🇵🇱","🇶🇦","🇷🇺","🇸🇲","🇸🇹","🇷🇸","🇸🇬","🇸🇮","🇸🇴","🇸🇸","🇧🇱","🇱🇨","🇸🇩","🇸🇪","🇹🇼","🇹🇭","🇹🇰","🇹🇳","🇹🇨","🇺🇬","🇸🇦","🇸🇨","🇸🇽","🇬🇸","🇿🇦","🇪🇸","🇸🇭","🇵🇲","🇸🇷","🇨🇭","🇹🇯","🇹🇱","🇹🇴","🇹🇷","🇹🇻","🇺🇦","🇸🇳","🇸🇱","🇸🇰","🇸🇧","🇰🇷","🇱🇰","🇰🇳","🇻🇨","🇸🇿","🇸🇾","🇹🇿","🇹🇬","🇹🇹","🇹🇲","🇻🇮","🇦🇪","🇬🇧","🇺🇿","🇻🇪","🇪🇭","🇿🇼","🇺🇸","🇻🇺","🇻🇳","🇾🇪","🇺🇾","🇻🇦","🇼🇫","🇿🇲"]
    ]
    
    func generateMenu() -> Menu {
        return Menu(label: "", leafs:   [emojiSet["faces"]![Int.random(in: 0 ..< emojiSet["faces"]!.count)],
                                         emojiSet["animals"]![Int.random(in: 0 ..< emojiSet["animals"]!.count)],
                                         emojiSet["people"]![Int.random(in: 0 ..< emojiSet["people"]!.count)],
                                         emojiSet["food"]![Int.random(in: 0 ..< emojiSet["food"]!.count)],
                                         emojiSet["activity"]![Int.random(in: 0 ..< emojiSet["activity"]!.count)],
                                         emojiSet["travel"]![Int.random(in: 0 ..< emojiSet["travel"]!.count)],
                                         emojiSet["flags"]![Int.random(in: 0 ..< emojiSet["flags"]!.count)],
                                         emojiSet["objects"]![Int.random(in: 0 ..< emojiSet["objects"]!.count)]].shuffled())
    }
    
    
    
    
}
